#ifndef ABSTRACT_EXAMPLE_H
#define ABSTRACT_EXAMPLE_H

#include "Scene.h"
#include "LightSourceProperties.h"
#include "AbstractProjectionSpec.h"
#include "MaterialColoring.h"
#include "SimpleMaterialColoring.h"
#include "SpacialSurfaceObject.h"
#include "SpacialSurfaceBuilder.h"
#include "SpacialCurveObject.h"
#include "SpacialCurveBuilder.h"

#define GLM_FORCE_RADIANS
#include <glm/gtc/matrix_transform.hpp>

//  diese Folge von include-Dateien ist nicht ideal, da mehr includiert
//  wird, als meist gebraucht wird.

class AbstractExample {
    public:
       AbstractExample();
       ~AbstractExample();
       AbstractExample(ColorSpec cc, ColorSpec al);
       virtual Scene* createScene() = 0;
       static const int NUMBER_OF_LIGHTS = 8;
    protected:
       ColorSpec clearColor;
       ColorSpec ambientLight;
       Scene* setupScene();
       AbstractProjectionSpec *projectionSpec;
       void initializeInstance();
       
       // Array für 8 Lichtquellen.
       LightSourceProperties lightSources[NUMBER_OF_LIGHTS];
       // Transformationsmatrix
       glm::mat4 transformationMatrix;
       // SliderSettings
};


#endif
