#ifndef ABSTRACT_TEXTURE_SPEC_H
#define ABSTRACT_TEXTURE_SPEC_H

#include "ColorSpec.h"
enum TextureFunction { ADD, MODULATE, DECAL, BLEND, REPLACE, COMBINE };

enum BlendFunction { ZERO, ONE, SRC_COLOR, ONE_MINUS_SRC_COLOR,
                     DST_COLOR, ONE_MINUS_DST_COLOR,
                     SRC_ALPHA, INE_MINUS_SRC_ALPHA,
                     DST_ALPHA, ONE_MINUS_DST_ALPHA,
                     SRC_ALPHA_SATURATE };

class AbstractTextureSpec {
    public:
      AbstractTextureSpec(ColorSpec cm, ColorSpec br, ColorSpec dk);
      ColorSpec getColorMask();
      ColorSpec* getPtrToColorMask();
      ColorSpec getBrightColor();
      ColorSpec* getPtrToBrightColor();
      ColorSpec getDarkColor();
      ColorSpec* getPtrToDarkColor();

    protected:
      ColorSpec colorMask;
      ColorSpec bright;
      ColorSpec dark;
};

#endif

