#ifndef APP_MODEL_H
#define APP_MODEL_H

#include <gtkmm.h>
#include "OpenGLSceneView.h"
#include "ControlPanel.h"

#include "Example001.h"   //  two helices
#include "Example001a.h"  //  helix with vertex coloration
#include "Example002.h"   //  Plucker surface
#include "Example002a.h"  //  Plucker surface
#include "Example002b.h"  //  Plucker surface
#include "Example003.h"   //  Torusknoten 5
#include "Example004.h"   //  Torusknoten 10
#include "Example005.h"   //  Withney's umbrella
#include "Example006.h"   //  Moebiusband
#include "Example007.h"   //  Sphärische Schraubenlinie
#include "Example009.h"   //  Schwingungen
#include "Example010.h"   //  two intersecting surfaces
#include "Example011.h"   //  Kleinsche Flasche offen
#include "Example012.h"   //  Kleinsche Flasche vollständig
#include "Example013.h"   //  Kleinsche Flasche offen
#include "Example014.h"   //  Kleinsche Flasche vollständig
#include "Example015.h"   //  Borromäische Ringe
#include "Example016.h"   //  Drei Spotlights
#include "Example017.h"   //  Drei Spotlights
#include "Example020.h"   //  spacial curves
#include "Example021.h"   //  spacial curves

class ApplicationModel {
	 public:
	    ApplicationModel(Glib::RefPtr<Gtk::Application> a);
	    void addWindow(Gtk::Window& w);
	    bool controlPanelIsOpen();
	    void openControlPanel();
	    void removeControlPanel();
	    SceneHolder& getSceneHolder();


        void onSelectItem01(Gtk::RadioMenuItem* item);
        void onSelectItem01a(Gtk::RadioMenuItem* item);
        void onSelectItem02(Gtk::RadioMenuItem* item);
        void onSelectItem02a(Gtk::RadioMenuItem* item);
        void onSelectItem02b(Gtk::RadioMenuItem* item);
        void onSelectItem03(Gtk::RadioMenuItem* item);
        void onSelectItem04(Gtk::RadioMenuItem* item);
        void onSelectItem05(Gtk::RadioMenuItem* item);
        void onSelectItem06(Gtk::RadioMenuItem* item);
        void onSelectItem07(Gtk::RadioMenuItem* item);
        void onSelectItem09(Gtk::RadioMenuItem* item);
        void onSelectItem10(Gtk::RadioMenuItem* item);
        void onSelectItem11(Gtk::RadioMenuItem* item);
        void onSelectItem12(Gtk::RadioMenuItem* item);
        void onSelectItem13(Gtk::RadioMenuItem* item);
        void onSelectItem14(Gtk::RadioMenuItem* item);
        void onSelectItem15(Gtk::RadioMenuItem* item);
        void onSelectItem16(Gtk::RadioMenuItem* item);
        void onSelectItem17(Gtk::RadioMenuItem* item);
        void onSelectItem20(Gtk::RadioMenuItem* item);
        void onSelectItem21(Gtk::RadioMenuItem* item);
   
        void onSelectToggleControlPanel();
        void aboutToCloseMainWindow();	    

	private:
        SceneHolder sceneHolder;
	    Glib::RefPtr<Gtk::Application> app;
	    ControlPanel *cp;
	    Example001  example001;
	    Example001a example001a;
	    Example002  example002;
	    Example002a example002a;
	    Example002b example002b;
	    Example003  example003;
	    Example004  example004;
	    Example005  example005;
	    Example006  example006;
	    Example007  example007;
	    Example009  example009;
	    Example010  example010;
	    Example011  example011;
	    Example012  example012;
	    Example013  example013;
	    Example014  example014;
	    Example015  example015;
	    Example016  example016;
	    Example017  example017;
	    Example020  example020;
	    Example021  example021;
};


#endif
