#ifndef COLOR_SPEC_H
#define COLOR_SPEC_H

#include "GLES/gl.h"  


class ColorSpec  {
    
    public:
      ColorSpec();
      ColorSpec(int r, int g, int b, int a = 1);
      ColorSpec(float r, float g, float b, float a = 1.0f);
      int getRedEditValue();
      int getGreenEditValue();
      int getBlueEditValue();
      int getAlphaEditValue();
      float getRedf();
      float getGreenf();
      float getBluef();
      float getAlphaf();
      const GLfloat* getColorSettings();
      void setRedValue(float v);
      void setGreenValue(float v);
      void setBlueValue(float v);
      void setAlphaValue(float v);
    
    private:
      GLfloat colors[4];
      void init(float r, float g, float b, float a );
};

#endif
