#ifndef CONTROL_PANEL_H
#define CONTROL_PANEL_H


#include <gtkmm.h>
#include "StagePropertiesPanel.h"
#include "ScenePropertiesPanel.h"
#include "ProjectionPropertiesPanel.h"

class ApplicationModel;

class ControlPanel  :  public Gtk::Window  {
	public:
	    ControlPanel(ApplicationModel& m);
	    ~ControlPanel();
	    void addWindow(Gtk::Window& w);
	    bool controlPanelIsOpen();
        virtual void onSceneChanged();
     
	protected:
	    bool onDeleteEvent(GdkEventAny* event);

	private:
       ApplicationModel& model;
       Gtk::Notebook notebook;
        
       StagePropertiesPanel* page1;
       ScenePropertiesPanel* page2;
       ProjectionPropertiesPanel* page3;
       
      
       static const char* LiteralTitle;
       static const char* LiteralTab1;
       static const char* LiteralTab2;
       static const char* LiteralTab3;
       
#ifdef TRACK_DESTROY_EVENTS      
       static void* notify1(void* data);
       static void* notify2(void* data);
       static void* notify3(void* data);
#endif
};


#endif
