#ifndef EXAMPLE_001_H
#define EXAMPLE_001_H

#include "AbstractSpacialCurveExample.h"
#include "SpacialPoint.h"

#include "AbstractExample.h"
#include "ParametricSpacialCurveEq.h"
#include "ParametricSpacialCurveSpec.h"


class Example001 : public AbstractExample,
                   public AbstractSpacialCurveExample  {
	friend class Example001a;    //  to allow access to the static constants
	
    public: 
      Example001();
      virtual Scene* createScene();

    protected:  
      void fn1 (float x, SpacialPoint* t);
      void fn1d1 (float x, SpacialPoint* t);
      void fn1d2 (float x, SpacialPoint* t);
      void fn2 (float x, SpacialPoint* t);
      void fn2d1 (float x, SpacialPoint* t);
      void fn2d2 (float x, SpacialPoint* t);
      ParametricSpacialCurveSpec c1;
      ParametricSpacialCurveSpec c2;
      
      TubularGridSpec polygonSpec1;
      TubularGridSpec polygonSpec2;
      ObjectDisplayFlags displayFlags1;
      ObjectDisplayFlags displayFlags2;
      //  hier sollte man die Werte direkt speichern  
      MaterialColoring mObj1;
      MaterialColoring mObj2;
      FogSpec fogSpec1;
      FogSpec fogSpec2;
      
      
      static const char* LiteralHelix1;
      static const char* LiteralHelix2;
};

#endif
