#ifndef EXAMPLE_001A_H
#define EXAMPLE_001A_H

#include "AbstractExample.h"
#include "AbstractSpacialCurveExample.h"
#include "SpacialPoint.h"
#include "TubularGridSpec.h"

class Example001a : public AbstractExample,
                    public AbstractSpacialCurveExample {
    public: 
      Example001a();
      virtual Scene* createScene();

    protected:  
      void fn1 (float x, SpacialPoint* t);
      void fn1d1 (float x, SpacialPoint* t);
      void fn1d2 (float x, SpacialPoint* t);
      void fn2 (float x, SpacialPoint* t);
      void fn2d1 (float x, SpacialPoint* t);
      void fn2d2 (float x, SpacialPoint* t);
      ParametricSpacialCurveSpec c1;
      ParametricSpacialCurveSpec c2;
      
      TubularGridSpec polygonSpec1;
      TubularGridSpec polygonSpec2;
      ObjectDisplayFlags displayFlags1;
      ObjectDisplayFlags displayFlags2;
      MaterialColoring mObj1;
      MaterialColoring mObj2;
      FogSpec fogSpec1;
      FogSpec fogSpec2;

    private:
      void createVertexColoring(TubularGridSpec* gridSpec,
                                SpacialSurfaceObject* obj);
      void createVertexColoring2(TubularGridSpec* gridSpec,
                                 SpacialSurfaceObject* obj);
      void convertToRGB(float hue, float s, float v, int* rgb);
      void scaleRgbToInt(float hue, float s, float v, int* rgb);
};

#endif
