#ifndef EXAMPLE_007_H
#define EXAMPLE_007_H

#include "AbstractExample.h"
#include "AbstractSpacialCurveExample.h"
#include "AbstractParametricFunctionExample.h"

class Example007 : public AbstractExample,
                   public AbstractSpacialCurveExample,
                   public AbstractParametricFunctionExample {
    public: 
      Example007();
      virtual Scene* createScene();

    protected:  
      void fn1 (float x, SpacialPoint* t);
      void fn1d1 (float x, SpacialPoint* t);
      void fn1d2 (float x, SpacialPoint* t);
      void fn2 (float phi, float t, VTriple* ft);
      void fn3 (float x, SpacialPoint* t);
      void fn3d1 (float x, SpacialPoint* t);
      void fn3d2 (float x, SpacialPoint* t);
      ParametricSpacialCurveSpec curveSpec1;
      ParametricSpacialCurveSpec curveSpec3;
      TubularGridSpec polygonSpec;
      MeshGrid gridSpec;
      ObjectDisplayFlags displayFlags1;
      ObjectDisplayFlags displayFlags2;
      ObjectDisplayFlags displayFlags3;
      SimpleMaterialColoring mObj1; 
      MaterialColoring mObj2; 
      SimpleMaterialColoring mObj3; 
      FogSpec fogSpec1;
      FogSpec fogSpec2;
      FogSpec fogSpec3;
      
      static const char* LiteralSurface1;
      static const char* LiteralSurface2;
      static const char* LiteralSurface3;
};

#endif
