#ifndef EXAMPLE_015_H
#define EXAMPLE_015_H

#include "AbstractExample.h"
#include "AbstractSpacialCurveExample.h"
#include "SpacialPoint.h"

class Example015 : public AbstractExample,
                   public AbstractSpacialCurveExample {
    public: 
      Example015();
      virtual Scene* createScene();

    protected:  
      void fn1 (float x, SpacialPoint* t);
      void fn1d1 (float x, SpacialPoint* t);
      void fn1d2 (float x, SpacialPoint* t);
      void fn2 (float x, SpacialPoint* t);
      void fn3 (float x, SpacialPoint* t);
      ParametricSpacialCurveSpec curveSpec1;
      ParametricSpacialCurveSpec curveSpec2;
      ParametricSpacialCurveSpec curveSpec3;
      
      TubularGridSpec polygonSpec1;
      TubularGridSpec polygonSpec2;
      TubularGridSpec polygonSpec3;
      ObjectDisplayFlags displayFlags1;
      ObjectDisplayFlags displayFlags2;
      ObjectDisplayFlags displayFlags3;
      SimpleMaterialColoring mObj1;
      SimpleMaterialColoring mObj2;
      SimpleMaterialColoring mObj3;
      FogSpec fogSpec1;
      FogSpec fogSpec2;
      FogSpec fogSpec3;
      
      static const char* LiteralRing1;
      static const char* LiteralRing2;
      static const char* LiteralRing3;
};

#endif
