#ifndef EXAMPLE_021_H
#define EXAMPLE_021_H

#include "AbstractExample.h"
#include "AbstractSpacialCurveExample.h"
#include "SpacialPoint.h"

class Example021 : public AbstractExample,
                   public AbstractSpacialCurveExample {
    public: 
      Example021();
      virtual Scene* createScene();

    protected:  
      void fn1 (float x, SpacialPoint* t);
      void fn2 (float x, SpacialPoint* t);
      ParametricSpacialCurveEquation curveSpec1;
      ParametricSpacialCurveEquation curveSpec2;
      PolylineSpec polygonSpec;
      ObjectDisplayFlags displayFlags1;
      ObjectDisplayFlags displayFlags2;
      MaterialColoring mObj1;
      MaterialColoring mObj2;
      FogSpec fogSpec1;
      FogSpec fogSpec2;
      
      void createVertexColoring(SpacialCurveObject* obj);
      void createVertexColoring2(SpacialCurveObject* obj);
      void convertToRGB(float hue, float s, float v, int* rgb);
      void scaleRgbToInt(float hue, float s, float v, int* rgb);
      
      static const char* LiteralHelix1;
      static const char* LiteralHelix2;
};

#endif
