#ifndef FOG_SPEC_EDITOR_H
#define FOG_SPEC_EDITOR_H

#include <gtkmm/adjustment.h>
#include <gtkmm/scale.h>
#include <gtkmm/box.h>
#include <gtkmm/frame.h>
#include <gtkmm/checkbutton.h>
#include "SceneHolder.h"
#include "ObjectSelectionObserver.h"

class SceneObjectsEditor;

class FogSpecEditor : public Gtk::Frame,
                      public ObjectSelectionObserver {

    public:
        FogSpecEditor(SceneHolder& sm, SceneObjectsEditor& se);
        ~FogSpecEditor();
        virtual void onObjectSelectionChanged();

    private:
        SceneHolder& sceneModel;
        SceneObjectsEditor& parentEditor;
        
        Glib::RefPtr<Gtk::Adjustment> red;
        Glib::RefPtr<Gtk::Adjustment> green;
        Glib::RefPtr<Gtk::Adjustment> blue;
        Glib::RefPtr<Gtk::Adjustment> beginOfFogRegion;
        Glib::RefPtr<Gtk::Adjustment> endOfFogRegion;
        Gtk::Scale reglerR;
        Gtk::Scale reglerG;
        Gtk::Scale reglerB;
        Gtk::Scale reglerBoF;
        Gtk::Scale reglerEoF;
        bool suspendUpdates;
        
        Gtk::Box container;	
        Gtk::Box container2;
        void onRValueChanged();
        void onGValueChanged();
        void onBValueChanged();
        void onBoFValueChanged();
        void onEoFValueChanged();
        
        void enableSliders();
        void disableSliders();
        
        static const char* LiteralShowFog;
};

#endif
