#ifndef LOGARITHMIC_SCALE_TRANSFORMATION_H
#define LOGARITHMIC_SCALE_TRANSFORMATION_H

#include <gtkmm/adjustment.h>
#include "AbstractScaleTransformation.h"

class LogarithmicScaleTransformation  : AbstractScaleTransformation {
	public:
	    LogarithmicScaleTransformation(Glib::RefPtr<Gtk::Adjustment> adj,
	           int b, int minE, int maxE);
	    virtual float scaleToValue(int sc);
	    virtual int valueToScale(float v);

    private:
        int minScaleValue;
        int maxScaleValue;
        int base;
        int minExponent;
        int maxExponent;
        int rangeOfScale;
        int rangeOfExponents;
        float scaledMinValue;
};

#endif
