#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

//#include <gtkmm.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/box.h>
#include <gtkmm/menubar.h>
#include <gtkmm/scale.h>
#include <gtkmm/table.h>

#include "ApplicationModel.h"
#include "SceneObserver.h"


class MainWindow :  public Gtk::Window,
                    public SceneObserver {

    public:
        MainWindow(Glib::RefPtr<Gtk::Application> app, ApplicationModel& m);
        virtual ~MainWindow();
        virtual void onSceneChanged();

    protected:
        Gtk::MenuBar menuBar;
        Glib::RefPtr<Gtk::Adjustment> adjustmentX;
        Glib::RefPtr<Gtk::Adjustment> adjustmentY;
        Glib::RefPtr<Gtk::Adjustment> adjustmentZ;
        Gtk::Scale reglerX;
        Gtk::Scale reglerY;
        Gtk::Scale reglerZ;
        Gtk::Box vbox;
        Gtk::Table grid;
        OpenGLSceneView paintArea;

        void onXValueChanged();
        void onYValueChanged();
        void onZValueChanged();
        bool onDeleteEvent(GdkEventAny* event);

    private:
   
        ApplicationModel& model;
        bool suspendUpdates;
        Gtk::RadioMenuItem* hiddenOption;
        
        static const char* windowTitle;
        static const char* sceneMenueTitle;
        static const char* sceneMenueItem01;
        static const char* sceneMenueItem02;
        static const char* sceneMenueItem03;
        static const char* sceneMenueItem04;
        static const char* sceneMenueItem05;
        static const char* sceneMenueItem06;
        static const char* sceneMenueItem07;
        static const char* sceneMenueItem08;
        static const char* sceneMenueItem09;
        static const char* sceneMenueItem10;
        static const char* sceneMenueItem11;
        static const char* sceneMenueItem12;
        static const char* sceneMenueItem13;
        static const char* sceneMenueItem14;
        static const char* sceneMenueItem15;
        static const char* sceneMenueItem16; 
        static const char* sceneMenueItem17;
        static const char* sceneMenueItem18;
        static const char* sceneMenueItem19;
        static const char* sceneMenueItem20;
        static const char* sceneMenueItem21;
        
        static const char* settingsMenueTitle;
        static const char* settingsMenueItem01;
};

#endif
