#ifndef MATERIAL_COLORING_H
#define MATERIAL_COLORING_H

#include "AbstractMaterial.h"
#include "MaterialProperties.h"
#include "AbstractSceneObject.h"

class MaterialColoring : public AbstractMaterial {
    public:
      MaterialColoring (MaterialProperties ff, MaterialProperties bf);
      virtual void install();
      virtual void renderColoredSurface(AbstractSceneObject* obj);
      virtual bool isSimpleColoring();
      void setFrontColoring();
      void setBackColoring();
      MaterialProperties* getFrontColoring();
      MaterialProperties* getBackColoring();
      
    protected:
      MaterialProperties frontFace;
      MaterialProperties backFace;
};

#endif
