#ifndef MATERIAL_PROPERTIES_H
#define MATERIAL_PROPERTIES_H

#include "ColorSpec.h"
#include "GLES/gl.h"  

class MaterialProperties {
    
    public:
      MaterialProperties(ColorSpec ac, ColorSpec dc,
             ColorSpec sc, ColorSpec ec, float sh);
      void installColoring();
      ColorSpec* getPtrToAmbientColor();
      ColorSpec* getPtrToDiffuseColor();
      ColorSpec* getPtrToSpecularColor();
      ColorSpec* getPtrToEmissiveColor();
      float getShininess();
      void setShininess(float s);
    
    private:
      ColorSpec ambientColor;
      ColorSpec diffuseColor;
      ColorSpec specularColor;
      ColorSpec emissiveColor;
      float shininess;
};

#endif
