#ifndef MATERIAL_PROPERTIES_EDITOR_H
#define MATERIAL_PROPERTIES_EDITOR_H


#include "SimpleMaterialPropertiesEditor.h"

class SceneObjectsEditor;

class MaterialPropertiesEditor : public SimpleMaterialPropertiesEditor {

    public:
        static MaterialPropertiesEditor* create(SceneHolder& sm, SceneObjectsEditor& se);
        ~MaterialPropertiesEditor();
        virtual void loadSceneObjectData();

    protected:
        MaterialPropertiesEditor(SceneHolder& sm, SceneObjectsEditor& se);

    private:
        Gtk::RadioButton noFaceBttn;
        Gtk::RadioButton frontFaceBttn;
        Gtk::RadioButton backFaceBttn;
        Gtk::Box bttnContainer;

        void noFaceBttnClicked();
        void frontFaceBttnClicked();
        void backFaceBttnClicked();
        
        virtual void configureComponents();
        virtual void buildForm();
        virtual void enableFirstSelection();
        virtual void disableFirstSelection();
        virtual void enableSecondSelection();
        virtual void disableSecondSelection(); 
        
        static const char* LiteralFront;
        static const char* LiteralBack;
};

#endif
