#ifndef OPEN_GL_SCENE_VIEW_H
#define OPEN_GL_SCENE_VIEW_H

#include <gtkmm/drawingarea.h>
#include "EGLInterface.h"
//#include "GLES/gl.h"
//#include "EGL/egl.h"
#include "EGL/eglext.h"

#include <iostream>
#include <assert.h>

#define GLM_FORCE_RADIANS
#include <glm/gtc/matrix_transform.hpp>

#include "Scene.h"
#include "SceneHolder.h"
#include "AttributeObserver.h"
#include "CameraSettings.h"

//#include "EGLTypes.h"

class OpenGLSceneView  : public Gtk::DrawingArea,
                         public AttributeObserver {

  public:
     OpenGLSceneView(SceneHolder& sh);
     ~OpenGLSceneView();
     void rotateX(double x);
     void rotateY(double y);
     void rotateZ(double z);
     void refresh();

     virtual void onSceneAttributesChanged();
     virtual bool on_configure_event(GdkEventConfigure* event);
     virtual bool on_draw(const Cairo::RefPtr<Cairo::Context> &context);

  private:
     SceneHolder& sceneModel;
     EGL_STATE_T _state;
     EGL_STATE_T *state;
     void init_model_proj(EGL_STATE_T* state);
     void reset_model(EGL_STATE_T* state);
     void redraw_scene(EGL_STATE_T* state);
     glm::mat4 rotationMatrix (float angle, SpacialPoint axis, SpacialPoint center);

};
#endif
