#ifndef SCENE_HOLDER_H
#define SCENE_HOLDER_H

#include "Scene.h"
#include "AttributeObserver.h"
#include "SceneObserver.h"
#include <list>

class SceneHolder {

public:
    SceneHolder();
    ~SceneHolder();
    void setScene(Scene* s);
    void deleteScene();
    bool hasScene();
    Scene* getScene();
    void addObserver (SceneObserver* observer);
    void removeObserver (SceneObserver* observer);
    void addAttributeObserver (AttributeObserver* observer);
    void removeAttributeObserver (AttributeObserver* observer);
    int observerCount();
    void notifyChange();
    void notifySceneAttributeChange();

protected:
    Scene* scene;
    std::list<SceneObserver*> observer;  //  das ist schon aufwendig
    std::list<AttributeObserver*> attributeObserver;

};

#endif
