#ifndef SPACIAL_POINT_H
#define SPACIAL_POINT_H
#include <glm/glm.hpp>
#include <iostream>

//
//  Eine Instanz stellt einen Raumpunkt durch Angabe seiner drei
//  Koordianten eines Raumpunkts in einem orthonormalen Koordinatensystem
//  dar.
//
//  Die arithmetischen Operationen mit Raumpunkten sollten
//  tatsaechlich als Operators definiert werden!
//

class SpacialPoint  {

public:
   SpacialPoint();  // warum ich diesen Konstruktor brauche, weiss ich nicht
   SpacialPoint(float px, float py, float pz);
   float getX() const;
   float getY() const;
   float getZ() const;
   float euclideanNorm();
   float dot(SpacialPoint);
   SpacialPoint safelyNormalized();
   SpacialPoint min(SpacialPoint pt);
   SpacialPoint max(SpacialPoint);
   SpacialPoint cross(SpacialPoint);
   glm::vec3 asVec3();
   
   
   SpacialPoint operator - ();
   friend SpacialPoint operator + (SpacialPoint sp1, SpacialPoint sp2);
   friend SpacialPoint operator - (SpacialPoint sp1, SpacialPoint sp2);
   friend SpacialPoint operator * (SpacialPoint sp1, SpacialPoint sp2);
   friend SpacialPoint operator * (SpacialPoint sp1, float factor);
   friend SpacialPoint operator * (float factor, SpacialPoint sp2);
   friend SpacialPoint operator / (SpacialPoint sp1, float d);
   friend std::ostream& operator << (std::ostream& os, const SpacialPoint& pt);

   float x;
   float y;
   float z;

};

#endif
