#ifndef SPACIAL_SURFACE_BUILDER_H
#define SPACIAL_SURFACE_BUILDER_H

#include "Triple.h"
#include "VTriple.h"
#include "ParametricSpacialCurveSpec.h"
#include "AbstractSpacialStructureBuilder.h"
#include "Integrators.h"
#include "ArcLengthIntegrand.h"
#include "SpacialSurfaceObject.h"
#include "BoundingBox.h"
#include "MeshGridSpec.h"
#include "TubularGridSpec.h"
#include "GLES/gl.h"  //  fuer GLfloat, GLushort


class AbstractParametricFunctionExample;  // forward decl
class AbstractSpacialFunctionExample;     // forward decl
class AbstractSpacialCurveExample;        // forward decl

class SpacialSurfaceBuilder : public AbstractSpacialStructureBuilder {
    
    public:
      static SpacialSurfaceObject* createFunctionMesh(
               ObjectDisplayFlags &objectSettings,
               MeshGrid *gridSpec,
               void (AbstractSpacialFunctionExample::*refFn)(float, float, Triple*),
               AbstractSpacialFunctionExample* inst);
               
      static SpacialSurfaceObject* createParametricFunctionMesh(
               ObjectDisplayFlags &objectSettings,
                    MeshGrid *gridSpec,
                    void (AbstractParametricFunctionExample::*refPFn)(float, float, VTriple*),
                    AbstractParametricFunctionExample* instPF);
                    
      static SpacialSurfaceObject* createTubularMesh(
               ObjectDisplayFlags &objectSettings,
                    TubularGridSpec *polylineSpec,
                    float radius,
                    ParametricSpacialCurveSpec* functions);
      
      //  preliminary:
      //  Erzeugung einer EmphasizedTexture
      static SpacialSurfaceObject* createTubularMesh2(
               ObjectDisplayFlags &objectSettings,
                    TubularGridSpec *polylineSpec,
                    float radius,
                    ParametricSpacialCurveSpec* functions);
};

#endif
