#ifndef SPACIAL_SURFACE_OBJ_H
#define SPACIAL_SURFACE_OBJ_H

#include "AbstractSceneObject.h"
#include "GLES/gl.h"  //  fuer GLfloat, GLushort

class SpacialSurfaceObject : public AbstractSceneObject {
    
    public:
      SpacialSurfaceObject(ObjectDisplayFlags &flags);
      ~SpacialSurfaceObject();
      SpacialSurfaceObject(ObjectDisplayFlags &flags, BoundingBox bb, GLfloat* v, GLfloat* vn, GLushort* idx, GLfloat* tc, int sIdx);
      SpacialSurfaceObject(ObjectDisplayFlags &flags, BoundingBox bb, GLfloat* v, GLfloat* vn, GLushort* idx, GLfloat* tc,
                           char* tb,  int tw, int th, int sIdx);

      virtual void renderObject();
      virtual void renderSimpleColoring(SimpleMaterialColoring* m);
      virtual void renderDoubleSidedColoring(MaterialColoring* m);
      
    private:
      GLfloat   *vertexNormals;
      GLushort  *indices;
      int /*sizeVertices, sizeVertexNormals, */ sizeIndices /* , sizeTextureCoords */;
      int textureWidth, textureHeight /*, textureBufferSize */;
      void renderTexturizedObject();
      void renderNonTexturizedObject();
};

#endif
