#ifndef STAGE_PROPERTIES_PANEL_H
#define STAGE_PROPERTIES_PANEL_H

#include <gtkmm/adjustment.h>
#include <gtkmm/box.h>
#include <gtkmm/frame.h>
#include <gtkmm/scale.h>
#include "SceneHolder.h"
#include "SceneObserver.h"

class StagePropertiesPanel :  public Gtk::Frame, public SceneObserver {

    public:
        StagePropertiesPanel(SceneHolder& sm);
        ~StagePropertiesPanel();
        virtual void onSceneChanged();
    private:
        SceneHolder& sceneModel;
        
        Glib::RefPtr<Gtk::Adjustment> red;
        Glib::RefPtr<Gtk::Adjustment> green;
        Glib::RefPtr<Gtk::Adjustment> blue;
        Glib::RefPtr<Gtk::Adjustment> bg_red;
        Glib::RefPtr<Gtk::Adjustment> bg_green;
        Glib::RefPtr<Gtk::Adjustment> bg_blue;
        Gtk::Frame labelLight;
        Gtk::Frame labelBackground;
        Gtk::Scale reglerR;
        Gtk::Scale reglerG;
        Gtk::Scale reglerB;
        Gtk::Scale bg_reglerR;
        Gtk::Scale bg_reglerG;
        Gtk::Scale bg_reglerB;
        Gtk::Box container1;
        Gtk::Box container2;
        Gtk::Box container3;
        bool suspendUpdates;
        void onRValueChanged();
        void onGValueChanged();
        void onBValueChanged();
        void onBG_RValueChanged();
        void onBG_GValueChanged();
        void onBG_BValueChanged();
        
        static const char* LiteralAmbientLight;
        static const char* LiteralBackgroundColor;
};

#endif
