#ifndef TEXTURE_PROPERTIES_EDITOR_H
#define TEXTURE_PROPERTIES_EDITOR_H

#include <gtkmm/box.h>
#include <gtkmm/frame.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/scale.h>
#include "SceneHolder.h"
#include "ObjectSelectionObserver.h"

class SceneObjectsEditor;

class TexturePropertiesEditor : public Gtk::Frame,
                                public ObjectSelectionObserver {

    public:
        TexturePropertiesEditor(SceneHolder& sm, SceneObjectsEditor& se);
        ~TexturePropertiesEditor();
        virtual void onObjectSelectionChanged();

    private:
        SceneHolder& sceneModel;
        SceneObjectsEditor& parentEditor;
        //Gtk::CheckButton showTextureBttn;
        Gtk::Box container;	
        Gtk::Box container1;	
        Gtk::Box container2;
        
        Glib::RefPtr<Gtk::Adjustment> red;
        Glib::RefPtr<Gtk::Adjustment> green;
        Glib::RefPtr<Gtk::Adjustment> blue;
        Gtk::Scale reglerR;
        Gtk::Scale reglerG;
        Gtk::Scale reglerB;
        bool suspendUpdates;
        	
        //void textureVisibilityToggled();
        void onRValueChanged();
        void onGValueChanged();
        void onBValueChanged();
        
        void enableSliders();
        void disableSliders();
        
        static const char* LiteralShowTexture;
};

#endif
