#include "AbstractExample.h"

AbstractExample::AbstractExample() {
	this -> initializeInstance();
};

AbstractExample::~AbstractExample() {
    delete projectionSpec;
};

void AbstractExample::initializeInstance() {
	for (int idx = 0; idx < NUMBER_OF_LIGHTS; idx++) {
		lightSources[idx].setLightID(LightSourceProperties::LIGHT_ID[idx]);
    }
    transformationMatrix = glm::mat4(1.0f);
}

AbstractExample::AbstractExample(ColorSpec cc, ColorSpec al) :
  clearColor(cc),
  ambientLight(al)
{ 
	  this -> initializeInstance();
}


Scene* AbstractExample::setupScene() {
	Scene* scene = new Scene(clearColor, ambientLight);
    scene -> addProjectionSpec(projectionSpec);
    scene -> addLightSources(lightSources);
    scene -> setTransformationMatrix(&transformationMatrix);
	return scene;
}
