#include "AbstractSpacialBox.h"

AbstractSpacialBox::AbstractSpacialBox() : 
    xDef(false),
    yDef(false),
    zDef(false) {
}

void AbstractSpacialBox::setXRange(float x0, float x1) {
    xMin = x0;
    xMax = x1;
    xDef = true;
}
void AbstractSpacialBox::setYRange(float y0, float y1) {
    yMin = y0;
    yMax = y1;
    yDef = true;
}
void AbstractSpacialBox::setZRange(float z0, float z1) {
    zMin = z0;
    zMax = z1;
    zDef = true;
}

void AbstractSpacialBox::processXValue(float x) {
    if (!xDef) {
        xMin = x;
        xMax = x;
        xDef = true;
    } else {
        xMin = xMin < x ? xMin : x;
        xMax = xMax > x ? xMax : x;
    }
}

void AbstractSpacialBox::processYValue(float y) {
    if (!yDef) {
        yMin = y;
        yMax = y;
        yDef = true;
    } else {
        yMin = yMin < y ? yMin : y;
        yMax = yMax > y ? yMax : y;
    }
}

void AbstractSpacialBox::processZValue(float z) {
    if (!zDef) {
        zMin = z;
        zMax = z;
        zDef = true;
    } else {
        zMin = zMin < z ? zMin : z;
        zMax = zMax > z ? zMax : z;
    }
}

void AbstractSpacialBox::processSpacialPoint(const SpacialPoint& pt) {
    processXValue(pt.getX());
    processYValue(pt.getY());
    processZValue(pt.getZ());
}


