#include "ApplicationModel.h"

#include <stddef.h>       //  für  NULL

ApplicationModel::ApplicationModel(Glib::RefPtr<Gtk::Application> a) : 
     app(a)
{
	cp = NULL;
}

bool ApplicationModel::controlPanelIsOpen() {
	return cp != NULL;
}

void ApplicationModel::addWindow(Gtk::Window& w) {
	app -> add_window(w);
}

void ApplicationModel::openControlPanel() {
	cp = new ControlPanel( *this);
	addWindow(*cp);
	cp -> show();
}

void ApplicationModel::removeControlPanel() {
	app -> remove_window(*cp);
	delete cp;
	cp = NULL;
}


SceneHolder& ApplicationModel::getSceneHolder() {
	return sceneHolder;
}

/*
 * Diese Methode wird von MainWindow aufgerufen, wenn MainWindow
 * geschlossen wird. Das ApplicationModel hat die Aufgabe,
 * alle unterstützenden Fenster zu schliessen.
 */
void ApplicationModel::aboutToCloseMainWindow() {
	if (cp != NULL) {
	    GdkEvent event;
	    event.type = GDK_DELETE;
	    event.any.window = &(*(cp -> get_window()).operator -> () -> gobj());
	    gtk_main_do_event(&event);
	    //cp -> event(&event);
	    //  in der kümmerlichen Dokumentation steht, dass 
	    //  gtk_main_do_event verwendet werden sollte
	}
}


void ApplicationModel::onSelectItem01(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example001.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem01a(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example001a.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem02(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example002.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem02a(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example002a.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem02b(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example002b.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem03(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example003.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem04(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example004.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem05(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example005.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem06(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example006.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem07(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example007.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem09(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example009.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem10(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example010.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem11(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example011.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem12(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example012.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem13(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example013.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem14(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example014.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem15(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example015.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem16(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example016.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem17(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example017.createScene();
		sceneHolder.setScene(sm);
	}
}


void ApplicationModel::onSelectItem20(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example020.createScene();
		sceneHolder.setScene(sm);
	}
}

void ApplicationModel::onSelectItem21(Gtk::RadioMenuItem* item) {
	if (item -> get_active()) {
		sceneHolder.deleteScene();
		Scene* sm = example021.createScene();
		sceneHolder.setScene(sm);
	}
}



void ApplicationModel::onSelectToggleControlPanel() {
	if (controlPanelIsOpen()) {
	    GdkEvent event;
	    event.type = GDK_DELETE;
	    cp -> event(&event);
	} else {
		openControlPanel();
	}
}
