#include "BoundingBox.h"

using namespace std;

BoundingBox BoundingBox::unionWith(BoundingBox& bb) {
    BoundingBox result;
    result.setXRange(xMin < bb.xMin ? xMin : bb.xMin, xMax > bb.xMax ? xMax : bb.xMax);
    result.setYRange(yMin < bb.yMin ? yMin : bb.yMin, yMax > bb.yMax ? yMax : bb.yMax);
    result.setZRange(zMin < bb.zMin ? zMin : bb.zMin, zMax > bb.zMax ? zMax : bb.zMax);
    return result;
}

void BoundingBox::addBox(BoundingBox* bb) {
    bb -> processXValue(xMin);
    bb -> processXValue(xMax);
    bb -> processYValue(yMin);
    bb -> processYValue(yMax);
    bb -> processZValue(zMin);
    bb -> processZValue(zMax);
}

//  Berechnung der Umkugel
Sphere BoundingBox::enclosingSphere() {
    SpacialPoint min = SpacialPoint(xMin, yMin, zMin);
    SpacialPoint max = SpacialPoint(xMax, yMax, zMax);
    SpacialPoint halfDiagonal = (max - min) / 2.0f;
    SpacialPoint center = min + halfDiagonal;
    float radius = halfDiagonal.euclideanNorm();
    return Sphere(center, radius);
}

ostream& operator << (ostream& os, const BoundingBox& bb) {
    os << "bb (" << bb.xMin << " : " << bb.xMax 
       << ", " << bb.yMin << " : " << bb.yMax
       << ", " << bb.zMin << " : " << bb.zMax << ")" << endl;
    return os;
}
