#include "ColorDisplayField.h"
#include <cairomm/context.h>

ColorDisplayField::ColorDisplayField()
: red(0.0),
  green(0.0),
  blue(0.0)
{
	//Gtk::Allocation allocation(1, 1, 10, 10);
	//size_allocate(allocation);
	set_size_request(26, 10);
}

void ColorDisplayField::setColor(float r, float g, float b) {
	red = r;
	green = g;
	blue = b;
	queue_draw();
}


void ColorDisplayField::setColor(ColorSpec* cs) {
	red = cs -> getRedf();
	green = cs -> getGreenf();
	blue = cs -> getBluef();
	queue_draw();
}

void ColorDisplayField::updateRedColorComponent(float r) {
	red = r;
	queue_draw();
	
}

void ColorDisplayField::updateGreenColorComponent(float g) {
	green = g;
	queue_draw();
	
}

void ColorDisplayField::updateBlueColorComponent(float b) {
	blue = b;
	queue_draw();
	
}


/*
 * Leider ist Cairo so langsam, dass die Anzeige kleiner Kreise selbst
 * ohne Antialiasing zu viel Zeit erfordert.
 */
bool ColorDisplayField::on_draw(const Cairo::RefPtr<Cairo::Context> &context) {
    Gtk::Allocation allocation = get_allocation();
    const int width = allocation.get_width();
    const int height = allocation.get_height();
    /*
    double xM = width / 2;
	double yM = height / 2;
	int s = height < width ? height : width;   //  kleinere Seite
	double radius = s / 2 - 2; */
    context->save();
    //context->set_antialias(Cairo::ANTIALIAS_NONE);
    //context->arc(xM, yM, radius, 0.0, 360.0f);
    context->rectangle(2, 2, width - 4, height - 4);
   
    context->set_source_rgb(red, green, blue);
    context->fill();
    context->restore();

    return true;
}
