#include "ColorSpec.h"

ColorSpec::ColorSpec() {
    init(0.0f, 0.0f, 0.0f, 1.0f);
}

ColorSpec::ColorSpec(int r, int g, int b, int a) {
    init(r/255.0f, g/255.0f, b/255.0f, a/255.0f);
};
    

    
ColorSpec::ColorSpec(float r, float g, float b, float a) {
    init(r, g, b, a);
};
    
void ColorSpec::init(float r, float g, float b, float a) {
    colors[0] = r;
    colors[1] = g;
    colors[2] = b;
    colors[3] = a;
}

int ColorSpec::getRedEditValue() {
    return (int) (colors[0]*255);
}

int ColorSpec::getGreenEditValue() {
    return (int) (colors[1]*255);
}

int ColorSpec::getBlueEditValue() {
    return (int) (colors[2]*255);
}

int ColorSpec::getAlphaEditValue() {
    return (int) (colors[3]*255);
}

float ColorSpec::getRedf() {
    return colors[0];
}

float ColorSpec::getGreenf() {
    return colors[1];
}

float ColorSpec::getBluef() {
    return colors[2];
}

float ColorSpec::getAlphaf() {
    return colors[3];
}

const GLfloat* ColorSpec::getColorSettings() {
    return &colors[0];
}

void ColorSpec::setRedValue(float v) {
    colors[0] = v;
}

void ColorSpec::setGreenValue(float v) {
    colors[1] = v;
}

void ColorSpec::setBlueValue(float v) {
    colors[2] = v;
}

void ColorSpec::setAlphaValue(float v) {
    colors[3] = v;
}
