#include "ControlPanel.h"
#include "ControlPanelStrings.h"
#include "ApplicationModel.h"



#ifdef TRACK_DESTROY_EVENTS

void* ControlPanel::notify1(void* data) {
	std::cout <<  "StagePropertiesPanel about to be destroyed" << std::endl;
	return (void*) 0;
}

void* ControlPanel::notify2(void* data) {
	std::cout <<  "ScenePropertiesPanel about to be destroyed" << std::endl;
	return (void*) 0;
}

void* ControlPanel::notify3(void* data) {
	std::cout <<  "PojectionPropertiesPanel about to be destroyed" << std::endl;
	return (void*) 0;
}

#endif


ControlPanel::ControlPanel(ApplicationModel& m) :
  model(m),
  notebook()
{
	set_title(ControlPanel::LiteralTitle);
    set_default_size(580, 650);
    add(notebook); 
    
    page1 = Gtk::manage(new StagePropertiesPanel(m.getSceneHolder()));
    page2 = Gtk::manage(new ScenePropertiesPanel(m.getSceneHolder()));
    page3 = Gtk::manage(new ProjectionPropertiesPanel(m.getSceneHolder()));
    
    notebook.append_page(
                    *page1, ControlPanel::LiteralTab1);
    notebook.append_page(
                    *page3, ControlPanel::LiteralTab3); 
    notebook.append_page(
                    *page2, ControlPanel::LiteralTab2); 

#ifdef TRACK_DESTROY_EVENTS     
    page1 -> add_destroy_notify_callback(this, ControlPanel::notify1);      
    page2 -> add_destroy_notify_callback(this, ControlPanel::notify2);    
    page3 -> add_destroy_notify_callback(this, ControlPanel::notify3);
#endif
                   
	signal_delete_event().
	     connect(sigc::mem_fun(*this, &ControlPanel::onDeleteEvent));
    show_all_children();
}

ControlPanel:: ~ControlPanel() {/*
	delete page1;
	delete page2;
	delete page3; */
}

bool ControlPanel::onDeleteEvent(GdkEventAny* event) {
	model.removeControlPanel();
	return false;  // Weiterbehandlung zulassen
};

//
//  gesendet von SceneHolder
//
void ControlPanel::onSceneChanged() {
}
