#include "FogSpec.h"
#include <iostream>

FogSpec::FogSpec(FogMode m, ColorSpec cs, float d, float s, float e)
:  fogMode(m),
   fogColor(cs),
   density(d),
   start(s),
   end(e)
{
}

void FogSpec::install() {
	float mode = GL_LINEAR;
	float nearDist, farDist;
	switch (fogMode) {
		case LINEAR:
		    mode = GL_LINEAR;
		    break;
		case EXP:
		    mode = GL_EXP;
		    break;
		case EXP2:
		    mode = GL_EXP2;
		    break;
    }
	nearDist = frontDistance + (backDistance - frontDistance)*start/100.0;
	farDist  = nearDist + (backDistance - frontDistance)*end/100.0;
	//std::cout << "(" << frontDistance <<", " << backDistance <<") " << "near dist " << nearDist << " far dist " << farDist << std::endl;
	glFogf(GL_FOG_MODE, mode);
	glFogfv(GL_FOG_COLOR, fogColor.getColorSettings());
	glFogf(GL_FOG_DENSITY, density);
	glFogf(GL_FOG_START, nearDist);
	glFogf(GL_FOG_END, farDist);
}

void FogSpec::setRegion(float sValue, float eValue) {
	frontDistance = sValue;
	backDistance = eValue;
}

ColorSpec* FogSpec::getRefToColor() {
	return &fogColor;
}

float FogSpec::getStartPosition() {
	return start;
}

float FogSpec::getEndPosition() {
	return end;
}

void FogSpec::setStartPosition (float sp) {
	start = sp;
}

void FogSpec::setEndPosition (float ep) {
	end = ep;
}
