#include "GLErrorHandler.h"
#include <cstdio>  // für printf
#include "GLES/gl.h" 

void GLErrorHandler::checkError(char const* cl, char const* method, char const* fn) {
	const char *fmtString = "%s in class: %s method: %s arg: %s\n";
	GLenum errorCode;
	errorCode = glGetError();
    switch (errorCode) { /*
		case GL_NO_ERROR:
		   printf(fmtString, "GL_NO_ERROR", cl, method, fn);
		   break;  */
		case GL_INVALID_ENUM:
		   printf(fmtString, "GL_INVALID_ENUM", cl, method, fn);
		   break;;
		case GL_INVALID_VALUE:
		   printf(fmtString, "GL_INVALID_VALUE", cl, method, fn);
		   break;;
		case GL_INVALID_OPERATION:
		   printf(fmtString, "GL_INVALID_OPERATION", cl, method, fn);
		   break;;
		case GL_STACK_OVERFLOW:
		   printf(fmtString, "GL_STACK_OVERFLOW", cl, method, fn);
		   break;;
		case GL_STACK_UNDERFLOW:
		   printf(fmtString, "GL_STACK_UNDERFLOW", cl, method, fn);
		   break;;
		case GL_OUT_OF_MEMORY:
		   printf(fmtString, "GL_OUT_OF_MEMORY", cl, method, fn);
		   break;
	}
}
