#include "LogarithmicScaleTransformation.h"
#include <cmath>

LogarithmicScaleTransformation::LogarithmicScaleTransformation(
        Glib::RefPtr<Gtk::Adjustment> adj,
	    int b, int minE, int maxE
       )
  : minScaleValue(adj -> get_lower()),
    maxScaleValue(adj -> get_upper() - 1), // get_upper lierft einen WErt, der um 1 über dem Maximalwert liegt
    base(b),
    minExponent(minE),
    maxExponent(maxE)
{
	rangeOfScale = maxScaleValue - minScaleValue;
	rangeOfExponents = maxExponent - minExponent;
	scaledMinValue = pow(base, minExponent);
}

float LogarithmicScaleTransformation::scaleToValue(int pv) {
	float v = pv;
	float rescaledValue = v/ rangeOfScale*rangeOfExponents - maxExponent;
	float res = exp(rescaledValue*log(base));
	return res;
}

int LogarithmicScaleTransformation::valueToScale(float v) {
	float normalizedValue =
	     v < scaledMinValue
	       ? 0.0
	       : (log(v)/log(base) - minExponent) / rangeOfExponents;
	return (int) lrintf(normalizedValue * rangeOfScale + minScaleValue);
}
