#include "MaterialColoring.h"

MaterialColoring::MaterialColoring(MaterialProperties ff, MaterialProperties bf)
     : frontFace(ff),
       backFace(bf) {
}

void MaterialColoring::install() {
}

void MaterialColoring::renderColoredSurface(AbstractSceneObject* obj) {
    obj -> renderDoubleSidedColoring(this);
}

bool MaterialColoring::isSimpleColoring() {
	return false;
}

MaterialProperties* MaterialColoring::getFrontColoring() {
	return &frontFace;
}

MaterialProperties* MaterialColoring::getBackColoring() {
	return &backFace;
}

void MaterialColoring::setFrontColoring() {
    frontFace.installColoring();
}

void MaterialColoring::setBackColoring() {
    backFace.installColoring();
}
