#include "MaterialProperties.h"
#include <iostream>

MaterialProperties::MaterialProperties(ColorSpec a, ColorSpec dc,
             ColorSpec sc, ColorSpec ec, float sh) 
             : ambientColor(a),
               diffuseColor(dc),
               specularColor(sc),
               emissiveColor(ec),
               shininess(sh) {
}

void MaterialProperties::installColoring() {
    
      glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ambientColor.getColorSettings());
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, diffuseColor.getColorSettings());
      glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specularColor.getColorSettings());
      glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, emissiveColor.getColorSettings());
      glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess); 
      //glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, &shininess);
}

ColorSpec* MaterialProperties::getPtrToAmbientColor() {
	return &ambientColor;
}

ColorSpec* MaterialProperties::getPtrToDiffuseColor() {
	return &diffuseColor;
}

ColorSpec* MaterialProperties::getPtrToSpecularColor() {
	return &specularColor;
}

ColorSpec* MaterialProperties::getPtrToEmissiveColor() {
	return &emissiveColor;
}

float MaterialProperties::getShininess() {
	return shininess;
}

void MaterialProperties::setShininess(float s) {
	shininess = s;
}
