#include "ObjectDisplayFlags.h"


ObjectDisplayFlags::ObjectDisplayFlags() :
   objectIsVisible(true),
   showTextureFlag(true),
   showFogFlag(false),
   showWireframeFlag(false),
   lightModelTwoSide(true)
{
	for (int i = 0; i < 8; i++) {
		lights[i] = true;
	}
}

bool ObjectDisplayFlags::isVisible() {
	return objectIsVisible;
}

bool ObjectDisplayFlags::showTexture() {
	return showTextureFlag;
}

bool ObjectDisplayFlags::showFog() {
	return showFogFlag;
}

bool ObjectDisplayFlags::showWireframe() {
	return showWireframeFlag;
}

bool ObjectDisplayFlags::useLightModelTwoSide() {
	return lightModelTwoSide;
}

void ObjectDisplayFlags::setVisibility(bool v) {
	objectIsVisible = v;
}

void ObjectDisplayFlags::setShowTexture(bool st) {
	showTextureFlag = st;
}

void ObjectDisplayFlags::setShowFog(bool sf) {
	showFogFlag = sf;
}

void ObjectDisplayFlags::setShowWireframe(bool v) {
	showWireframeFlag = v;
}

void ObjectDisplayFlags::setLightModelTwoSide(bool v) {
	lightModelTwoSide = v;
}

void ObjectDisplayFlags::toggleShowObject() {
	objectIsVisible = !objectIsVisible;
}

void ObjectDisplayFlags::toggleShowTexture() {
	showTextureFlag = !showTextureFlag;
}

void ObjectDisplayFlags::toggleShowFog() {
	showFogFlag = !showFogFlag;
}

void ObjectDisplayFlags::toggleShowWireframe() {
	showWireframeFlag = ! showWireframeFlag;
}

void ObjectDisplayFlags::toggleLightModelTwoSide() {
	lightModelTwoSide = !lightModelTwoSide;
}

void ObjectDisplayFlags::toggleLightSource(int i) {
	lights[i] = ! lights[i];
}
