#include "GLES/gl.h"
#include "OrthographicProjectionSpec.h"
#include "Scene.h"
#include "ViewBox.h"

using namespace std;

OrthographicProjectionSpec::OrthographicProjectionSpec()
{
}

OrthographicProjectionSpec::~OrthographicProjectionSpec()
{
	//std::cout << "OrthographicProjectionSpec deleted" << std::endl;
}

void OrthographicProjectionSpec::setViewpoint(Scene* sc) {
}

void OrthographicProjectionSpec::setSpace(Scene* sc) {
    Sphere sp = sc -> enclosingSphere();
    SpacialPoint center = sp.getCenterPoint();
    CameraSettings* cs = sc -> getCameraSettings();

    //ViewBox cube = ViewBox(SpacialPoint(0.0f, 0.0f, 0.0f));
    float radius = sp.getRadius();
    float distanceFromCenter = (/*center*/ cs -> target - cs -> position).euclideanNorm();
    /*
    cube.setXRange( -radius, radius);
    cube.setYRange( -radius, radius);
    cube.setZRange(distanceFromCenter -radius, distanceFromCenter + radius);
    glOrthof(cube.xMin, cube.xMax,
             cube.yMin, cube.yMax,
             cube.zMin, cube.zMax); */


    // Um die Bildaufrichtung in der GPU zu erledigen, ist
    // es geschickter, eine Transformationsmatrix anzugeben,
    // die das Vorzeichen der transformierten y-Werte umkehrt.
    // Dann muss allerdings auch der Umlaufsinn der Dreicksvertices
    // auf clockwise umgestellt werden.
    float halfDistance = radius*zoomFactor;
    float left  = - halfDistance;
    float right =   halfDistance;
    float buttom =  - halfDistance;
    float top    =    halfDistance;
    float nearZ = distanceFromCenter - radius;
    float farZ  = distanceFromCenter + radius;
    float aspect = 1.0;
    mat[0] = 2.0f/(right - left);
    mat[1] = 0.0f;
    mat[2] = 0.0f;
    mat[3] = 0.0f;
    mat[4] = 0.0f;
    mat[5] = 2.0f/(top- buttom);   //  Aufrichtefunktion
    mat[6] = 0.0f;
    mat[7] = 0.0f;
    mat[7] = 0.0f;
    mat[9] = 0.0f;
    mat[10] = 2.0f/(nearZ - farZ);
    mat[11] = 0.0f;
    mat[12] = -(right + left)/(right - left);
    mat[13] = -(top + buttom)/(top - buttom);   // verändertes Vorzeichen für Aufrichtung
    mat[14] = -(farZ + nearZ)/(farZ - nearZ);
    mat[15] = 1.0f;

    glFrontFace(GL_CCW);  //  erforderlich, falls die Transformation die
                         //  Bildaufrichtung leisten soll, ohne dass
                         //  Vorderseitenfarbe und Rückseitenfarbe
                         //  vertauscht werden.
                         //  Die Bildaufrichtung in der Transformation
                         //  ausführen zu lassen, ermöglicht eine
                         //  raschere Bildabfolge.
    glLoadMatrixf(mat);

}
