#include "SceneHolder.h"
//#include <iostream>

SceneHolder::SceneHolder() :
    scene((Scene*) 0)
{
}

SceneHolder::~SceneHolder() {
    delete scene;
}

void SceneHolder::setScene(Scene* s) {
    if (scene != (Scene*) 0) {
        delete scene;
    }
    scene = s;
    //std::cout << "scene set, about to notify change" << std::endl;
    notifyChange();
    //std:: cout << "change set" << std::endl;
}
void SceneHolder::deleteScene() {
    if (scene != (Scene*) 0) {
        delete scene;
        scene = (Scene*) 0;
    }
    //std::cout << "scene deleted, about to notify change" << std::endl;
    notifyChange();
    //std:: cout << "change notified" << std::endl;
}

bool SceneHolder::hasScene() {
    return scene != (Scene*) 0;
}

Scene* SceneHolder::getScene() {
    return scene;
}

void SceneHolder::addObserver(SceneObserver* obs) {
    observer.push_back(obs);
}

void SceneHolder::removeObserver(SceneObserver* obs) {
    std::list<SceneObserver*>::iterator it = observer.begin();
    while (it != observer.end()) {
        if ((*it) == obs) {
	        observer.erase(it); 
			it++;
			break;
	    } else {
			++it;
		}
    }
}

void SceneHolder::addAttributeObserver(AttributeObserver* obs) {
    attributeObserver.push_back(obs);
}

void SceneHolder::removeAttributeObserver(AttributeObserver* obs) {
    std::list<AttributeObserver*>::iterator it = attributeObserver.begin();
    while (it != attributeObserver.end()) {
        if ((*it) == obs) {
	        attributeObserver.erase(it); 
			it++;
			break;
	    } else {
			++it;
		}
    }
}

int SceneHolder::observerCount() {
    return observer.size();
}

void SceneHolder::notifyChange() {
    for (std::list<SceneObserver*>::iterator it = observer.begin(); it != observer.end(); ++it) {
        (*it) -> onSceneChanged();
    }
}

void SceneHolder::notifySceneAttributeChange() {
    for (std::list<AttributeObserver*>::iterator it = attributeObserver.begin(); it != attributeObserver.end(); ++it) {
        (*it) -> onSceneAttributesChanged();
    }
}
    
