#include "TexturePropertiesEditor.h"
#include "TexturePropertiesEditorStrings.h"
#include "SceneObjectsEditor.h"
#include <iostream>

TexturePropertiesEditor::TexturePropertiesEditor (SceneHolder& sm, SceneObjectsEditor& se)
: sceneModel(sm),
  parentEditor(se),
  //(TexturePropertiesEditor::LiteralShowTexture),
  container(Gtk::ORIENTATION_VERTICAL),
  //container1(Gtk::ORIENTATION_HORIZONTAL),
  container2(Gtk::ORIENTATION_VERTICAL),
  red(Gtk::Adjustment::create(0.0, 0.0, 256.0, 1.0, 1.0, 1.0)),
  green(Gtk::Adjustment::create(0.0, 0.0, 256.0, 1.0, 1.0, 1.0)),
  blue(Gtk::Adjustment::create(0.0, 0.0, 256.0, 1.0, 1.0, 1.0)),
  reglerR(red, Gtk::ORIENTATION_HORIZONTAL),
  reglerG(green, Gtk::ORIENTATION_HORIZONTAL),
  reglerB(blue, Gtk::ORIENTATION_HORIZONTAL),
  suspendUpdates(false)
{
	parentEditor.addObserver(this);
	add(container);
	
	reglerR.set_value_pos(Gtk::POS_LEFT);
    reglerG.set_value_pos(Gtk::POS_LEFT);
    reglerB.set_value_pos(Gtk::POS_LEFT);
    reglerR.set_digits(0);
    reglerG.set_digits(0);
    reglerB.set_digits(0);
    
	//container1.pack_start(showTextureBttn, Gtk::PACK_SHRINK);
	container2.pack_start(reglerR, Gtk::PACK_SHRINK);
    container2.pack_start(reglerG, Gtk::PACK_SHRINK);
    container2.pack_start(reglerB, Gtk::PACK_SHRINK);
    
    //container.pack_start(container1, false, false);
    container.pack_start(container2, true, true);
    /*
	showTextureBttn.signal_toggled().connect(
         sigc::mem_fun(*this, &TexturePropertiesEditor::textureVisibilityToggled)); */
    red->signal_value_changed().connect(sigc::mem_fun(*this, &TexturePropertiesEditor::onRValueChanged));
    green->signal_value_changed().connect(sigc::mem_fun(*this, &TexturePropertiesEditor::onGValueChanged));
    blue->signal_value_changed().connect(sigc::mem_fun(*this, &TexturePropertiesEditor::onBValueChanged));


	container.show();
}

TexturePropertiesEditor::~TexturePropertiesEditor() {
	parentEditor.removeObserver(this);
}



void TexturePropertiesEditor::onObjectSelectionChanged() {
	//std::cout  <<  "TexturePropertiesEditor received object selection notification" << std::endl;
	if (parentEditor.hasCurrentSelection()) {
		AbstractSceneObject* obj = parentEditor.getCurrentlySelectedObject();
		//showTextureBttn.set_active(obj -> showTexture());
	} else {
	}
}

/*
void TexturePropertiesEditor::textureVisibilityToggled() {
	if (parentEditor.hasCurrentSelection()) {
	    parentEditor.getCurrentlySelectedObject() -> setShowTexture(showTextureBttn.get_active());
	    sceneModel.notifySceneAttributeChange();
	}
}
*/


void TexturePropertiesEditor::onRValueChanged() { /*
	if ((!suspendUpdates)) {
	    AbstractSceneObject* obj = parentEditor.getCurrentlySelectedObject();
        ColorSpec* currentlySelectedColor = obj -> getFogSpec() -> getRefToColor();
        currentlySelectedColor->setRedValue(reglerR.get_value()/255.0f);
        //currentColorDisplayField->updateRedColorComponent(reglerR.get_value()/255.0f);
        sceneModel.notifySceneAttributeChange();
	} */
}

void TexturePropertiesEditor::onGValueChanged() { /*
	if ((!suspendUpdates)) {
	    AbstractSceneObject* obj = parentEditor.getCurrentlySelectedObject();
        ColorSpec* currentlySelectedColor = obj -> getFogSpec() -> getRefToColor();
        currentlySelectedColor->setGreenValue(reglerG.get_value()/255.0f);
        //currentColorDisplayField->updateGreenColorComponent(reglerG.get_value()/255.0f);
        sceneModel.notifySceneAttributeChange();
	} */
}

void TexturePropertiesEditor::onBValueChanged() { /*
	if ((!suspendUpdates)) {
	    AbstractSceneObject* obj = parentEditor.getCurrentlySelectedObject();
        ColorSpec* currentlySelectedColor = obj -> getFogSpec() -> getRefToColor();
        currentlySelectedColor->setBlueValue(reglerB.get_value()/255.0f);
        //currentColorDisplayField->updateBlueColorComponent(reglerB.get_value()/255.0f);
        sceneModel.notifySceneAttributeChange();
	} */
}


void TexturePropertiesEditor::enableSliders() {
	container2.set_sensitive(true); 
}

void TexturePropertiesEditor::disableSliders() {
	container2.set_sensitive(false);
}
